<template>
  <ele-modal
    custom-class="ele-dialog-form long-dialog-form"
    :centered="true"
    :visible.sync="addSaleOrderDialogFlag"
    :title="title"
    :close-on-click-modal="false"
    width="70%"
    :before-close="cancel"
  >
    <el-form ref="form" :model="form" :rules="rules" label-width="120px">
      <headerTitle title="发货信息"></headerTitle>
      <el-row>
        <el-col :span="12">
          <el-form-item
            label="销售订单"
            prop="orderNo"

            style="margin-bottom: 22px"
          >
            <el-input
              disabled
              v-model="form.orderNo"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item
            label="客户名称"
            prop="contactName"
            style="margin-bottom: 22px"
          >
            <span>{{ form.contactName }}</span>
          </el-form-item>
          <el-form-item
            label="计价方式"
            style="margin-bottom: 22px">
            <el-select v-model="form.pricingWay" disabled style="width: 100%">
              <el-option label="按数量计费" :value="1"></el-option>
              <el-option label="按重量计费" :value="2"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item
            label="客户联系人"
            prop="linkName"
            style="margin-bottom: 22px"
          >
            <el-input clearable v-model="form.linkName" placeholder="请输入"/>
          </el-form-item>

          <el-form-item prop="sendFiles" label="发货附件">
            <fileUpload
              v-model="form.sendFiles"
              module="main"
              :showLib="false"
              :limit="10"
            />
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <el-form-item label="车辆号" prop="carNo" style="margin-bottom: 22px">
            <el-input clearable v-model="form.carNo" placeholder="请输入"/>
          </el-form-item>

          <!-- <el-form-item
              label="订单编码"
              prop="orderNo"
              style="margin-bottom: 22px"
            >
            <span>{{form.orderNo}}</span>

            </el-form-item> -->

          <el-form-item
            label="客户电话"
            prop="linkPhone"
            style="margin-bottom: 22px"
          >
            <el-input clearable v-model="form.linkPhone" placeholder="请输入"/>
          </el-form-item>
          <el-form-item
            label="收货地址"
            prop="receiveAddress"
            style="margin-bottom: 22px"
          >
            <el-input
              clearable
              v-model="form.receiveAddress"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item prop="repliedFiles" label="回执附件">
            <fileUpload
              v-model="form.repliedFiles"
              module="main"
              :showLib="false"
              :limit="10"
            />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>

    <headerTitle title="产品清单" style="margin-top: 30px"></headerTitle>
    <inventoryTable
      :pricingWay="form.pricingWay"
      :entrustedCode="form.entrustedCode"
      :isShowAdd='false'
      ref="inventoryTableref"
      :orderId="form.orderId"
    ></inventoryTable>

    <div slot="footer" class="footer">
      <el-button type="primary" @click="save">保存</el-button>
      <el-button type="primary" @click="save('sub')">提交</el-button>

      <el-button @click="cancel">返回</el-button>
    </div>
  </ele-modal>
</template>

<script>
import fileUpload from '@/components/upload/fileUpload';
import dictMixins from '@/mixins/dictMixins';
import parentList from '@/views/saleManage/contact/components/parentList.vue';
import {
  addSendInformation,
  UpdateSendInformation,
  submit
} from '@/api/saleManage/saleordersendrecord';
import {getSaleOrderSendInfoAPI, saleReturnHandleUpdateReceipt} from '@/api/saleManage/returnGoods';
import inventoryTable from './inventoryTable.vue';
import {copyObj} from '@/utils/util';

export default {
  name: 'add-sale-order-dialog',
  props: ['addSaleOrderDialogFlag'],
  mixins: [dictMixins],
  components: {
    fileUpload,
    inventoryTable,
    parentList
  },
  data() {
    let formDef = {
      id: '',
      contractId: '',
      sendFiles: [],
      repliedFiles: [],
      contractName: '',
      receiveAddress: '',
      carNo: '',
      carId: '',
      linkName: '',
      linkPhone: '',
      orderNo: '',
      orderId: '',
      replied: 0
    };

    return {
      title: '',
      row: {},
      formDef,
      form: copyObj(formDef),
      rules: {
        partaName: [
          {required: true, message: '请选择客户名称', trigger: 'change'}
        ],
        linkName: [
          {required: true, message: '请输入', trigger: ['blur', 'change']}
        ],
        orderNo: [
          {required: true, message: '请选择', trigger: 'change'}
        ],
        receiveAddress: [
          {required: true, message: '请输入', trigger: 'change'}
        ],
      },
      // 提交状态
      loading: false,
      // 是否是修改
      isUpdate: false,
      businessId: ''
    };
  },
  methods: {
    //初始化数据
    init(row = {}) {
      this.title = '新增发货单';
      this.currentRow = row;
      this.getSendSaleOrderDetail(row.id)
    },
    //发货单详情
    async getSendSaleOrderDetail(id) {
      this.businessId = id;
      this.loading = true;
      const data = await getSaleOrderSendInfoAPI(id);
      this.loading = false;
      if (data) {
        this.$nextTick(() => {
          this.form = data;
          this.form.pricingWay = data.saleOrder.pricingWay
          this.$nextTick(()=>{
            this.$refs.inventoryTableref &&
            this.$refs.inventoryTableref.putTableValue(data.productList);
          })
        });
      }
    },

    getValidate() {
      return Promise.all([
        new Promise((resolve, reject) => {
          this.$refs.form.validate((valid) => {
            if (!valid) {
              reject(false);
            } else {
              resolve(true);
            }
          });
        }),
        new Promise((resolve, reject) => {
          this.$refs.inventoryTableref.validateForm((valid) => {
            if (!valid) {
              reject(false);
            } else {
              resolve(true);
            }
          });
        })
      ]);
    },
    async save(type) {
      try {
        await this.getValidate();
        // 表单验证通过，执行保存操作
        this.loading = true;

        if (!this.isUpdate) {
          delete this.form.id;
        }
        this.form.repliedFiles = this.form.repliedFiles || [];
        this.form.replied = this.form.repliedFiles.length > 0 ? 1 : 0;
        let commitData = Object.assign({}, this.form, {
          productList: this.$refs.inventoryTableref.getTableValue()
        });

        addSendInformation(commitData)
          .then((res) => {
            this.loading = false;
            this.$message.success('新增成功');
            saleReturnHandleUpdateReceipt({id: this.currentRow.id, resendId: res})
            if (type === 'sub') {
              this.sendSubmit(res);
              return;
            }
            this.cancel();
            this.$emit('done');
          })
          .catch((e) => {
            //this.loading = false;
          });
      } catch (error) {
        console.log(error);
        // 表单验证未通过，不执行保存操作
      }
    },
    sendSubmit(res) {
      submit({
        businessId: res
        // productionSupervisorId
      }).then((res) => {
        this.cancel();
        this.$emit('done');
      });
    },
    cancel() {
      this.$emit('update:addSaleOrderDialogFlag', false)
    },
    reload() {
      this.$emit('done')
    }
  }
};
</script>
<style scoped lang="scss">
.TotalAmount {
  font-size: 16px;
  padding-right: 30px;
}

.headbox {
  display: flex;
  justify-content: flex-start;
  align-items: center;

  .amount {
    font-size: 14px;
    font-weight: bold;
    margin-right: 20px;
  }
}
</style>
